.686p
.model  flat, stdcall
option  casemap :none   ; case sensitive
.xmm
.nolist
include windows.inc

uselib  MACRO   libname
    include     libname.inc
    includelib  libname.lib
ENDM

uselib user32
uselib kernel32
uselib comctl32
uselib gdi32
uselib msimg32
;uselib shell32
;uselib comdlg32
;uselib masm32
;uselib debug

inv equ Invoke

;scratch for tests
.data?
align 4
temp1   dd ?    ; aligned
temp2   dd ?
buff db 200 dup (?)
dwtoabuf db 12 dup (?)
align 8
count2 dq ?
.data
crlf db 13,10,0
acrlf dd offset crlf
abuff dd offset buff
.code
MaxTests    equ 99          ; maximum number of timing tests, increase as desired up to 999


soff Macro QuotedText:Vararg    ; returns offset to a string
Local LocalText
.data
LocalText db QuotedText,0
.code
EXITM <offset LocalText>
Endm

Desc Macro TextVal:Req  ; used in the first line of each test proc (Test1....Testxx)
local DescLoc, FirstFlag
.data
FirstFlag dd 0
DescLoc db TextVal,0
.code
    .if FirstFlag==0    ; if not first time, just continue
        mov FirstFlag,1 ; set done for next time
        mov ebx,offset DescLoc
        call SetDesc
        ret     ; if this was the first time, just return without running rest of code
    .endif
endm

Showit Macro longint:req
    pusha
    mov eax,TestNum
    add eax,6000
    inv SetDlgItemInt,hWin,eax,longint,0
    popa
endm

.data?
align 16
hWin          dd ?  ; dialog handle
hEdit         dd ?
StartingCycle dd ?
CyclePart2    dd ?
Loops         dd ?
ExtraLoops    dd ?
Min           dd ?
sample dd ?
curr   dd ?
Result        dd ?
CurAnsHandle  dd ?
mean1          dd ?
mean2          dd ?
plotf dd ?
statsbuffer dd 2000 dup (?)  ; value,count
nextfreestat    dd ?
average dd ?
mean    dd ?
median  dd ?
points  dd ?
.data
Overhead      dd 0   ; overhead of doing an empty proc
Overheadflg   dd 0
.code

ExtraLoopSize = 10  ; number of times to warm up the cache before testing
BeginCounter macro  ; This macro is inserted before a block of test code
    align 16    ; just to be sure all code starts with equal advantage
    pusha

if saveplot
    call SetupSavePlot
endif

if tsttype eq DoAvg     ;; old style
    
	mov Loops,TimesToLoop
    mov [StartingCycle],eax     ; just to make sure they are in the cache
    mov [StartingCycle+4],eax
    Repeat 6    ; Intel says 4 but I've found that more works a little better
    xor eax,eax
    cpuid       ;; call the EAX=0 version of CPUID to clear pipeline (serialize) (finish any pending instructions)
    Endm
    xor eax,eax
	align 16	; just to be sure all code starts with equal advantage
	nop        ; adjust so actual test code starts on 16 byte boundary
	cpuid 		; call the EAX=0 version of CPUID to clear pipeline (serialize) (finish any pending instructions)
	rdtsc
	mov	[StartingCycle],eax
	mov	[StartingCycle+4],edx
TimingLoop = $

else    ;; DoMin, DoSep, DoMode

    call SetupTests
ExtraLoopsLoop = $
    sub ExtraLoops,1
TimingLoop = $
    mov [StartingCycle],eax     ; just to make sure they are in the cache
    mov [StartingCycle+4],eax
    Repeat 6    ; Intel says 4 but I've found that more works a little better
     xor eax,eax
     cpuid       ; call the EAX=0 version of CPUID to clear pipeline (serialize) (finish any pending instructions)
    Endm
    rdtsc
    mov [StartingCycle],eax
    mov [StartingCycle+4],edx

endif
endm

EndCounter macro        ; This macro is inserted after each block of test code

if tsttype eq DoAvg  ;; oldstyle

    sub Loops,1
    jnz TimingLoop
    xor eax,eax
    cpuid       ; flush
    rdtsc
	sub eax,[StartingCycle]	; get result in EDX:EAX
	sbb edx,[StartingCycle+4]
	mov ecx,TimesToLoop		; divide by number of times through the loop
	div ecx				; result of division in EAX, remainder in EDX
    sub eax,Overhead
    .if sdword ptr eax<0
        mov eax,0
    .endif        
    mov Result,eax

else

    xor eax,eax
    cpuid       ; flush
    rdtsc
    cmp ExtraLoops,0
    jne ExtraLoopsLoop  ; skip first several iterations to warm up the cache
    call WrapupTests
    sub Loops,1
    jnz TimingLoop

endif

if tsttype eq DoMin

    mov eax,Min
    mov Result,eax
        
elseif tsttype eq DoSep

    mov eax,mean1
    mov edx,mean2
    mov ecx,TimesToLoop
    div ecx
    mov Result,eax

endif

if tsttype ne DoAvg
    call FinalWrap
endif

    if saveplot
        inv CloseHandle,plotf
    endif
             
    popa
endm


msg Macro qtext:VARARG
local result
pusha
    quote SUBSTR <qtext>,1,1
    IFIDN quote , <">  ;; if this is a quoted string
        invoke MessageBox,0,soff(qtext),0,0
    else
        result=opattr(qtext)
        if result eq 48 ;; a register
            invoke MessageBox,0,qtext,0,0
        else
            invoke MessageBox,0,addr qtext,0,0
        endif
    endif   
popa
endm

prtd MACRO argf ; debugging print
pusha
mov eax,argf
mov edi,offset dwtoabuf
call dwtoax2
invoke MessageBox,0,addr dwtoabuf,0,0
popa
EndM

GetHandle Macro MyId:Req,MyHandle:Req 
    invoke GetDlgItem,hWin,MyId
    mov MyHandle,eax         ; save handle to control
endm

include Printx.inc
.listall

SetupTests proc
    mov Min,-1 ;9999999999
    mov sample,1
    mov mean1,0
    mov mean2,0
    mov Loops,TimesToLoop
    .if Loops > 1000
       msg "maximum times to loop is 1000.  There is no reason to do more, and much less is just as good."
       mov Loops,1000
    .endif
    mov ExtraLoops,ExtraLoopSize  ; will do several times first to let things settle out
    mov nextfreestat,offset statsbuffer
	ret
SetupTests endp
WrapupTests proc
    sub eax,[StartingCycle] ; get result in EDX:EAX
    sbb edx,[StartingCycle+4]

    sub eax,Overhead
    .if sign?
        xor eax,eax
    .endif
    cmp Min,eax
    jb @f
    mov Min,eax
@@:
    mov curr,eax
    add mean1,eax   ; keep running average
    adc mean2,edx
    mov ebx,offset statsbuffer
    .repeat ; curr in eax
        .if ebx==nextfreestat  ; new one, store it
            mov [ebx],eax   ; curr
            mov dword ptr [ebx+4],1
            add nextfreestat,8
            .break
        .elseif eax==[ebx]
            add dword ptr [ebx+4],1
            .break
        .elseif eax<[ebx] ; move all point up and insert new point
            mov edi,nextfreestat
            add edi,4
            mov esi,edi
            sub esi,8
            add nextfreestat,8
            mov ecx,edi
            sub ecx,ebx ; number of bytes to move
            shr ecx,2
            std
            rep movsd            
            cld
            mov [ebx],eax
            mov dword ptr [ebx+4],1
            .break
        .endif
        add ebx,8
    .until 0
    if saveplot
        printx abuff
        printxa dd,sample," ",dd,curr,crlf
        inv _lwrite,plotf,abuff,printxsize
    endif    
    inc sample    
    mov ExtraLoops,ExtraLoopSize   ; will do several times first to let things settle out
	ret
WrapupTests endp
FinalWrap proc
    local hstats,mid,tmp
    mov mid,TimesToLoop/2
    mov esi,offset statsbuffer
    mov edi,0
    mov eax,mid
    .repeat
        add edi,[esi+4]
        .if edi >= mid
            mov eax,[esi]
            mov median,eax
            .break
        .endif
        add esi,8
    .until esi>=nextfreestat
    inv _lcreat,soff("Stats.txt"),0
    mov hstats,eax
    mov esi,offset statsbuffer
    mov tmp,0
    .repeat
        printx abuff
        mov eax,[esi+4]
        add tmp,eax
        printxa dd,[esi]," ",dd,[esi+4]," ",dd,tmp,crlf
        inv _lwrite,hstats,abuff,printxsize
        add esi,8
    .until esi>=nextfreestat
    inv CloseHandle,hstats   
	ret
FinalWrap endp
SetupSavePlot proc
    inv _lcreat,soff("Plot.txt"),0
    mov plotf,eax
	ret
SetupSavePlot endp

Program:
    invoke  InitCommonControls
    invoke  GetModuleHandle, NULL
    mov edx,offset DlgProc
    invoke  DialogBoxParam, eax, 101, 0, edx, 0
    invoke  ExitProcess, eax
