TimesToLoop  equ 100;0;0;0;0;0 ; number of times to loop
PrintResults equ 01   ; Print to results.txst file if non-zero
DoMin=1 ; time each loop, pick minimum timing
DoAvg=2 ; run all loops continuously and average
DoSep=3 ; time each loop, average results
DoMode=4 ; which value occurs most often
tsttype=3; DoMin/DoAvg/DoSep
saveplot=0;1    ; prints out plot.txt file containing time for each trial.  DoMin and DoSep only
PriClass textequ <REALTIME_PRIORITY_CLASS> ; priority to use for tests
;PriClass textequ <NORMAL_PRIORITY_CLASS>   ; for debugging

include Part1.inc

; -------------------------------------  Timing Tests -----------------------------------

; This is the code to copy to create new timing tests. Copy this code and paste it below.
; Change the X in TestX to a number (Test1, Test2,...Test99)
TestX:
    Desc ' ' ;insert description of this test between single quotes
    ; -- place any setup desired here.  Registers will not be preserved into test code --
    BeginCounter    ; place test code here between BeginCounter and EndCounter ----------

    EndCounter      ; end of test code --------------------------------------------------
    ;Showit LongInt ; result value to show in rightmost box on each line
    ret

;--------------------------------- Test Procs/data -------------------------------------------

;  Place any test procs or setup/checking procs you wish here

.data?
align 16
bufsize equ 65536
buf1 db bufsize dup (?)
buf2 db bufsize dup (?)
answers db bufsize dup (?)
.data
tststring db 'abcdabcDabCdabCDaBcdaBcDaBCdaBCDAbcdAbcDAbCdAbCDABcdABcDABDdABCD'  ;64
          db '0bcda0cDab0dabC0\Bcda\cDaB\daBC\~bcdA~cDAb~dAbC~'  ; 64-16
          db 1,2,3,4,252,253,254,255,1,"a",255,"z",255,255,"c",255 ; +16 = 128 chars
ansstring DB 'ABCDABCDABCDABCDABCDABCDABCDABCDABCDABCDABCDABCDABCDABCDABDDABCD'  ;64
          DB '0BCDA0CDAB0DABC0\BCDA\CDAB\DABC\~BCDA~CDAB~DABC~'  ; 64-16
          DB 1,2,3,4,252,253,254,255,1,"A",255,"Z",255,255,"C",255 ; +16 = 128 CHARS
.code
SetBuf proc uses esi edi ebx
    ; make a string of 65536 characters long by repeating the 128 byte test string
   
    mov edx,bufsize/4
    mov edi,offset buf1
@@:
    mov ecx,128/4   ; make test strings
    mov esi,offset tststring
    rep movsd
    sub edx,128/4
    jnz @b
    
    ; make an answer string for checking results
    mov edx,bufsize/4
    mov edi,offset answers
@@:
    mov ecx,128/4   ; make answers
    mov esi,offset ansstring
    rep movsd
    sub edx,128/4
    jnz @b

    ; preset results to be sure it wasn't leftovers
    mov ecx,bufsize/4
    mov edi,offset buf2
    mov eax,'zyxw'  ; something we can spot as an error
    rep stosd
    ret
SetBuf EndP

ChkUpper proc uses esi edi  ; check the answer
    mov esi,offset answers
    mov edi,offset buf2
    mov ecx,bufsize/4
@@:
    mov eax,[edi]
    cmp eax,[esi]
    jne errx
    add esi,4
    add edi,4
    sub ecx,1
    jnz @b
    ret
errx:
    msg "error in results"
    mov [edi+16],byte ptr 0
    inv MessageBox,0,edi,0,0
    ret
ChkUpper EndP
.data?
CaseTable db 256 dup (?)
CaseTable2 db 65536*2 dup (?)
.code
MakeCaseTable proc  ; make a 256 byte lookup table
    mov eax,offset CaseTable
    mov edx,0
MakeTable:
    mov byte ptr[eax],dl
    cmp dl,'a'
    jb  @f      ; ok
    cmp dl,'z'
    ja  @f
    xor byte ptr[eax],20h   ; flip bit
@@:
    inc eax
    inc edx
    or  dl,dl
    jnz MakeTable
    ret
MakeCaseTable EndP

MakeCaseTable2 proc ; make a 65536 word lookup table
    mov eax,offset CaseTable2
    mov edx,0
MakeTable:
    mov ecx,edx
    cmp cl,'a'
    jb  @f      ; ok
    cmp cl,'z'
    ja  @f
    xor cl,20h  ; flip bit
@@:
    cmp ch,'a'
    jb  @f      ; ok
    cmp ch,'z'
    ja  @f
    xor ch,20h  ; flip bit
@@:
    mov word ptr[eax],cx
    add eax,2
    inc edx
    or  dx,dx
    jnz MakeTable
    ret
MakeCaseTable2 EndP

;-----------------------------------------------------------------------
;-----------------------------------------------------------------------
;                      Tests
;-----------------------------------------------------------------------
;-----------------------------------------------------------------------
       
Test1:
    Desc 'Original Jimbo routine'
    inv SetBuf
    inv MakeCaseTable
    BeginCounter

    mov esi,offset buf1
    mov edi,offset buf2
    mov ecx,bufsize
    mov edx,offset CaseTable
    xor eax,eax
@@:
    mov al,[esi]
    mov al,[edx+eax]
    mov [edi],al
    add esi,1h
    add edi,1h
    sub ecx,1h
    jnz @b

    EndCounter
    inv ChkUpper
    ret
    
Test2:
    Desc 'drizz routine'
    inv SetBuf
    inv MakeCaseTable
    BeginCounter

    mov esi,offset buf1
    mov edi,offset buf2
    mov ecx,bufsize
    mov edx,offset CaseTable
    
    add esi,ecx
    add edi,ecx
    neg ecx
@@:
    movzx eax,byte ptr [esi+ecx]
    movzx eax,byte ptr [edx+eax]
    mov [edi+ecx],al
    add ecx,1
    jnz @b  
    
    EndCounter
    inv ChkUpper
    ret

Test3:
    Desc 'drizz routine 2'
    inv SetBuf
    inv MakeCaseTable
    BeginCounter

    mov esi,offset buf1
    mov edi,offset buf2
    mov ecx,bufsize
    mov edx,offset CaseTable
    
    add esi,ecx
    add edi,ecx
    neg ecx
    test ecx,1
    jnz @F
loopc:
    movzx eax,byte ptr [esi+ecx]
    movzx eax,byte ptr [edx+eax]
    mov [edi+ecx],al
    add ecx,1
@@: movzx eax,byte ptr [esi+ecx]
    movzx eax,byte ptr [edx+eax]
    mov [edi+ecx],al
    add ecx,1
    jnz loopc   

    EndCounter
    inv ChkUpper
    ret

Test4:
    Desc 'lingo'
    inv SetBuf
    inv MakeCaseTable
    BeginCounter

    mov esi,offset buf1
    mov edi,offset buf2
    mov ecx,bufsize
    mov edx,offset CaseTable
    xor eax,eax

@@:
    movzx eax, byte ptr [esi+ecx-1]
    sub ecx, 1
    mov al, [edx+eax]
    mov [edi+ecx],al
    jne @b
    
    EndCounter
    inv ChkUpper
    ret
    

Test5:
    Desc 'chrisw routine'
    inv SetBuf
    inv MakeCaseTable
    BeginCounter

    mov esi,offset buf1
    mov edi,offset buf2
    mov ecx,bufsize
    mov edx,offset CaseTable
    xor eax,eax

    sub    ecx,    3
    add    esi,    ecx
    add    edi,    ecx
    neg    ecx
    jns    loopc_entry

loopc4:

    movzx    eax,    byte ptr [esi+ecx]
    movzx    ebx,    byte ptr [edx+eax]

    movzx    eax,    byte ptr [esi+ecx+1]
    movzx    eax,    byte ptr [edx+eax]
    shl      eax,    8
    or       ebx,    eax

    movzx    eax,    byte ptr [esi+ecx+2]
    movzx    eax,    byte ptr [edx+eax]
    shl      eax,    16
    or       ebx,    eax

    movzx    eax,    byte ptr [esi+ecx+3]
    movzx    eax,    byte ptr [edx+eax]
    shl      eax,    24
    or       ebx,    eax

    mov      [edi+ecx],    ebx
    add      ecx,          4

    js loopc4
    jmp loopc_entry
    
loopc2:

    movzx    eax,    byte ptr [esi+ecx]
    movzx    eax,    byte ptr [edx+eax]

    mov      [edi+ecx],  al
    add      ecx,        1

loopc_entry:
    cmp      ecx,    3

    jl loopc2


    EndCounter
    inv ChkUpper
    ret
    

Test12:       ;---------------------------------------------------------------------------
    Desc 'using table lookup'
    inv SetBuf
    inv MakeCaseTable
    BeginCounter
    mov esi,offset buf1
    mov edi,offset buf2
    mov ecx,bufsize ; work backwards from end of buffer
    mov ebx,offset CaseTable
@@:
    sub ecx,1
    jc  @f      ; done
    movzx eax,byte ptr[esi+ecx]
    mov al,[ebx+eax]    ; pick up replacement character
    mov [edi+ecx],al
    jmp @b  
@@:
    EndCounter
    inv ChkUpper
    ret

Test13:       ;---------------------------------------------------------------------------
    Desc 'using table and dword pickup, byte store'
    inv SetBuf
    inv MakeCaseTable
    BeginCounter
    mov esi,offset buf1
    mov edi,offset buf2
    mov ecx,bufsize ; work backwards from end of buffer
    mov ebx,offset CaseTable
    mov eax,0
@@:
    sub ecx,4
    jc  @f      ; done
    mov edx,[esi+ecx]
    mov al,dl
    mov al,[ebx+eax]    ; pick up replacement character
    mov [edi+ecx],al
    mov al,dh
    mov al,[ebx+eax]    ; pick up replacement character
    mov [edi+ecx+1],al
    shr edx,16
    mov al,dl
    mov al,[ebx+eax]    ; pick up replacement character
    mov [edi+ecx+2],al
    mov al,dh
    mov al,[ebx+eax]    ; pick up replacement character
    mov [edi+ecx+3],al
    
    jmp @b  

@@:
    EndCounter
    inv ChkUpper
    ret
    
Test14:       ;---------------------------------------------------------------------------
    Desc 'using table, dword pickup and store, shrshl'
    inv SetBuf
    inv MakeCaseTable
    
    BeginCounter
    align 16
    mov esi,offset buf1
    mov edi,offset buf2
    mov ecx,bufsize-4   ; work backwards from end of buffer
    mov ebx,offset CaseTable
    mov eax,0
@@:
    mov edx,[esi+ecx]
    push ecx
    mov al,dl
    mov cl,[ebx+eax]    ; pick up replacement character
    mov al,dh
    mov ch,[ebx+eax]    ; pick up replacement character
    shr edx,16
    mov al,dl
    mov dl,[ebx+eax]    ; pick up replacement character
    mov al,dh
    mov dh,[ebx+eax]    ; pick up replacement character
    shl edx,16
    mov dx,cx
    pop ecx
    mov [edi+ecx],edx
    sub ecx,4
    jnc @b

@@:
    EndCounter
    inv ChkUpper
    ret
    
        
Test15:       ;---------------------------------------------------------------------------
    Desc 'using table, dword pickup and store, shrshl'
    inv SetBuf
    inv MakeCaseTable
    
    BeginCounter
    align 16
    mov edi,offset buf2
    mov esi,bufsize-4   ; work backwards from end of buffer
    mov ebx,offset CaseTable
    mov eax,0
    nop
    nop
@@:     ; best alignment at address ending in 6
    mov edx,[esi+offset buf1]
    mov al,dl
    mov cl,[ebx+eax]    ; pick up replacement character
    mov al,dh
    mov ch,[ebx+eax]    ; pick up replacement character
    shr edx,16
    mov al,dl
    mov dl,[ebx+eax]    ; pick up replacement character
    mov al,dh
    mov dh,[ebx+eax]    ; pick up replacement character
    shl edx,16
    mov dx,cx
    mov [edi+esi],edx
    sub esi,4
    jnc @b

    EndCounter
    inv ChkUpper
    ret

Test16:       ;---------------------------------------------------------------------------
    Desc 'using table, dword pickup and store, shrshl, ebp'
    inv SetBuf
    inv MakeCaseTable
    
    BeginCounter
    align 16
    mov edi,offset buf2
    mov esi,bufsize-4   ; work backwards from end of buffer
    push ebp
    mov ebp,offset CaseTable
    xor eax,eax
    mov ebx,eax
@@:    
    mov edx,[offset buf1+esi]
    mov al,dl
    mov bl,dh
    mov cl,[ebp+eax]    ; pick up replacement character
    mov ch,[ebp+ebx]    ; pick up replacement character
    shr edx,16
    mov al,dl
    mov bl,dh
    mov dl,[ebp+eax]    ; pick up replacement character
    mov dh,[ebp+ebx]    ; pick up replacement character
    shl edx,16
    mov dx,cx
    mov [edi+esi],edx
    sub esi,4
    jnc @b
    pop ebp
    EndCounter
    inv ChkUpper
    ret

Test18:      ;---------------------------------------------------------------------------
    Desc 'using table, dword pickup and store, ebp'
    inv SetBuf
    inv MakeCaseTable
    
    BeginCounter
    align 16
    push ebp
    mov edi,offset buf2
    mov esi,bufsize-4   ; work backwards from end of buffer
    mov ebp,offset buf1
    mov ebx,offset CaseTable
    mov eax,0
    nop
    nop
@@:     ; best alignment at address ending in C
    mov edx,[esi+ebp]
    mov al,dl
    mov cl,[ebx+eax]    ; pick up replacement character
    mov al,dh
    mov ch,[ebx+eax]    ; pick up replacement character
    shr edx,16
    mov al,dl
    mov dl,[ebx+eax]    ; pick up replacement character
    mov al,dh
    mov dh,[ebx+eax]    ; pick up replacement character
    shl edx,16
    mov dx,cx
    mov [edi+esi],edx
    sub esi,4
    jnc @b
    pop ebp
    EndCounter
    inv ChkUpper
    ret

.data
BytesRead dd bufsize
.code
Test20:       ;---------------------------------------------------------------------------
    Desc 'using word size table, dword pickup and store, adjust to even dword' 
    inv SetBuf
    inv MakeCaseTable2
    BeginCounter
    mov esi,offset buf1 
    mov edi,offset buf2
    align 16
    mov ecx,BytesRead   ; work backwards from end of buffer
    ;sub ecx,4          ; work from end of buffer
    ;add    ecx,3       ; round up to nearest even dword
    sub ecx,1       ; equivalent of sub 4, add 3
    and ecx,not 3
    mov ebx,offset CaseTable2
    nop
    nop
    nop
    nop
    nop
@@:         ; best alignment at address ending in 6 for AMD
    movzx edx,word ptr [esi+ecx+2]
    movzx eax,word ptr [esi+ecx]
    mov edx,[ebx+edx*2-2]   ; pick up replacement characters, upper half+junk
    mov dx,[ebx+eax*2]  ; pick up replacement characters, lower half
    mov [edi+ecx],edx
    sub ecx,4
    jnc @b
    EndCounter
    inv ChkUpper
    ret



;               ------------------------ end of timing tests --------------------
include Part2.inc